import sgmllib

# az sgmllib tartalmaz egy minta class-t; az alapjn kszlt ez is
# ez a verzi csak a <a href=...> </a> prost rzi meg, minden mst konvertl
# ha olyan tag-et akarsz lekezelni akinek nincs zrtag-je, akkor
# do_tagnv nev metdust kell ltrehoznod; egybknt meg start_tagnv s end_tagnv pros kell
class HtmlConverter(sgmllib.SGMLParser):

    def __init__(self, verbose=0):
        self.testdata = "" #a nyit s zr tag kztti szveg kerl ebbe
        sgmllib.SGMLParser.__init__(self, verbose)

    def handle_data(self, data):
	"""
	    a nyit s zr tag kztti szveg kezelsre val,
	    ezt hvogatja az alap class(SGMLParser), de nem felttlenl egyszerre az egsz szveggel,
	    lehet, hogy darabokban;
	    a 70-es hossz figyelse+flush nem felttlen szksges; csak ezzel
            akadlyozzuk meg, hogy a testdata puffer tl nagyra njjn.	 	
	"""
        self.testdata = self.testdata + data
        if len(`self.testdata`) >= 70:
            self.flush()

    def flush(self):
	"""
	   a testdata puffert rtjk, tartalma az stdout-ra kerl
	"""
        data = self.testdata
        if data:
            self.testdata = ""
            print data

    def start_a(self, attrs):
	"""
	   <a ...> tag-et tallt az alapclass, akkor ezt hvja meg
	   megrizzk az eredeti formt,  de eltte rtjk a testdata puffert
	"""
        self.flush()
        print '<a' ,
        for name, value in attrs:
            print name + '=' + '"' + value + '"',
        print '>'

    def end_a(self):
	"""
	   </a> tag-et tallt az alapclass, akkor ezt hvja meg
	   megrizzk az eredeti formt, de eltte rtjk a testdata puffert
	"""
        self.flush()
        print '</a>'

    def unknown_starttag(self, tag, attrs):
	"""
	   ismeretlen tag-et tallt az alapclass(azaz nincs start_tagnv metdusa), akkor ezt hvja meg
	   konvertlunk, de eltte rtjk a testdata puffert
	"""
        self.flush()
        print '<blockquote>&lt;' + tag,
        for name, value in attrs:
            print name + '=' + '"' + value + '"',
        print '&gt;'

    def unknown_endtag(self, tag):
	"""
	   ismeretlen zr tag-et tallt az alapclass(azaz nincs end_tagnv metdusa), akkor ezt hvja meg
	   konvertlunk, de eltte rtjk a testdata puffert
	"""
        self.flush()
        print '&lt;/' + tag + '&gt;</blockquote>'

    def close(self):
        sgmllib.SGMLParser.close(self)
        self.flush()


def test(args = None):
    import sys

    # paramtere lehet fjl vagy '-', utbbi esetben stdin-rl olvas
    if not args:
        args = sys.argv[1:]

    if args:
        file = args[0]
    else:
        file = 'start.html' # ez a default input fjl

    if file == '-':
        f = sys.stdin
    else:
        try:
            f = open(file, 'r')
        except IOError, msg:
            print file, ":", msg
            sys.exit(1)

    # beolvasom az input tartalmt
    data = f.read()
    if f is not sys.stdin:
        f.close()

    # csinlok egy instance-t s megettetem vele az input fjl tartalmt
    # a feed fog gondoskodni a class megfelel metdusainak hvsrl
    x = HtmlConverter()
    for c in data:
        x.feed(c)
    x.close()


if __name__ == '__main__':
    test()
